# 🧑‍💻 Contributing to the Home Assistant Newt Add-on

Thanks for your interest in contributing to the **Newt Add-on** for Home Assistant!  
We welcome all kinds of contributions — from code, testing, documentation, translations, and feedback.

---

## 📌 Quick Links

- 📦 Add-on Repository: https://github.com/Ferdinand99/home-assistant-newt-addon
- 📚 Documentation: https://docs.fossorial.io/Newt/overview
- 💬 Community: Join us on Discord → https://discord.gg/fTHY3ZM8nY

---

## 🧭 Ways to Contribute

| Type                      | How to Help                                                   |
|---------------------------|---------------------------------------------------------------|
| 🐛 Report Bugs            | Use the `#🐛・bug-reports` channel on Discord or open an issue |
| 🔧 Suggest Features       | Use `#🔧・feature-requests` or GitHub Issues                    |
| 👥 Code Contributions     | PRs are welcome! See coding guidelines below                   |
| 📖 Improve Documentation  | Fix typos, clarify steps, or update setup info                |
| 🌍 Translate              | Add or improve localization (coming soon)                     |
| 🧠 Community Support      | Help answer questions in `#❓・questions` or `#setup-help`     |

---

## 🔧 Getting Started (For Developers)

1. **Fork the repo** and clone it to your machine
2. Check out [Home Assistant Developer Tools](https://developers.home-assistant.io/docs/add-ons/)
3. Test your changes using the Home Assistant Add-on system

---

## 🛠 Folder Structure

/home-assistant-newt-addon/
├── config.json # Add-on manifest
├── Dockerfile # Add-on runtime environment
├── run.sh # Entrypoint script
├── README.md # Project overview
└── ... # Other internal files


---

## ✅ Code Style & Rules

- Follow **PEP8** (Python) or **Bash best practices** where applicable
- Use **descriptive commit messages**
- Keep PRs focused: one feature/fix per PR
- Test your changes in Home Assistant if possible
- Use code blocks and logs for debugging in Discord discussions

---

## 🧪 Testing

If you're submitting a fix or feature:
- Provide clear **reproduction steps** or **test cases**
- Add logs or screenshots if helpful
- Indicate what platform/setup you tested on (HAOS, Docker, etc.)

---

## 📥 Pull Request Guidelines

- Branch from `main`
- Include a clear title and description
- Reference related issues or discussions
- Mark PRs as `Draft` if still in progress
- Use threads in Discord `#👥・code-contributions` for coordination

---

## 💬 Need Help?

Join the Discord and post in:

- `#❓・questions` — for general confusion
- `#👥・code-contributions` — for development collab
- `#📚・documentation` — if you're improving the docs

---

Let’s build something awesome together! 🚀
